#ifndef MAZEGAME_H_
#define MAZEGAME_H_
#include "MapSite.h"
#include "Maze.h"
class MazeGame {
	public:
		MazeGame();
		virtual ~MazeGame();
		static Maze *createMaze() {
			Maze *m=new Maze();
			Room *r1=new Room(1),*r2=new Room(2);
			Door *d=new Door(r1,r2);
			m->addRoom(r1);
			m->addRoom(r2);
			r1->setSide(MapSite::north,new Wall()); // flyweight?
			r1->setSide(MapSite::south,new Wall());
			r1->setSide(MapSite::east,d);
			r1->setSide(MapSite::west,new Wall());
			r2->setSide(MapSite::north,new Wall());
			r2->setSide(MapSite::south,new Wall());
			r2->setSide(MapSite::east,new Wall());
			r2->setSide(MapSite::west,d);
			//for(MapSite::Direction d=MapSite::north;d<MapSite::directions;d=(MapSite::Direction)(d+1)) cout << r1->getSide(d) << endl;
			return m;
		}
	};
#endif /*MAZEGAME_H_*/
