#include <set>
#include "../inc/Maze.h"
Maze::Maze() {}
Maze::~Maze() {
	set<MapSite *>toBeDeleted;
	// have maze own the doors!
	cout << "in ~Maze()" << endl;
	cout << rooms_.size() << "rooms" << endl;
	for(map<int,Room *>::const_iterator i=rooms_.begin();i!=rooms_.end();++i) {
		MapSite *ms=i->second;
		toBeDeleted.insert(i->second);
		Room * r=dynamic_cast<Room *>(ms);
		if(r!=NULL)
			for(MapSite::Direction d=MapSite::north;d<MapSite::directions;d=(MapSite::Direction)(d+1))
				if(r->getSide(d))
					toBeDeleted.insert(r->getSide(d));
	}
	cout << "deleting " << toBeDeleted.size() << " map sites" << endl;
	for(set<MapSite *>::const_iterator i=toBeDeleted.begin();i!=toBeDeleted.end();++i) 
		delete *i;
}
void Maze::addRoom(Room *room) {
	rooms_.insert(map<int,Room *>::value_type(room->getNumber(),room));
}
Room *Maze::getRoom(int const number) const {
	map<int,Room *>::const_iterator i=rooms_.find(number);
	return i!=rooms_.end()?i->second:NULL;
}
